#version 420 core 

//in vec2 TexCoord;
in vec3 position_cameraspace;
in vec3 normal_cameraspace;
in vec4 screenPos;

in vec2 TexCoord;

out vec4 color;

//light properties
//uniform vec3 LightPosition_worldspace;
//uniform vec4 LightColor;
//uniform float LightPower;

//uniform samplerCube cube_texture;
uniform sampler2D _refractSceneTexture;

uniform sampler2D _normalSampler;

uniform mat4 InverseView; 
//out vec4 frag_colour;

//uniform float Material_refractionRatio;

void main()
{
	
/*
	//reflect ray around normal from eye to surface
  	
	vec3 incident_eye	= normalize(position_cameraspace);
  	vec3 normal			= normalize(normal_cameraspace);
  	vec3 reflected		= reflect(incident_eye, normal);
  	
	// convert from eye to world space
  	//reflected = vec3(inverse(V) * vec4(reflected, 0.0));

	//material parameter. Find parameters for glass(y) material and water (~1.3)
	
	vec3 refracted = refract(incident_eye, normal, ratio);
	
	float ratio = 1.0 / 1.1;

	reflected = vec3(InverseView * vec4(reflected, 0.0));
	refracted = vec3(InverseView * vec4(refracted, 0.0));
*/
	//issue: this line doesnt work on my laptop (either the integrated intel card or gtx 860m) 
	//and also on my computer (AMD R9 390)
	//...but seems to work according to the tutorial
	//vec4 colTemp = texture(_refractSceneTexture, refracted); 


	//vec2 screenUV = (screenPos.xy / screenPos.w) + bumpTex.xy * ratio;
	//vec2 screenUV = vec2(screenPos.x, screenPos.y) / screenPos.w + bumpTex.xy * ratio;
	//(screenPos.xy / screenPos.w) + bumpTex.xy * ratio;
	float ratio = 1.0 / 1.1;

	vec4 bumpTex = 2.0 * texture(_normalSampler, TexCoord) - 1.0;

	vec2 screenUV  = refract(
		vec3(screenPos.x, -screenPos.y, screenPos.z) / screenPos.w
		,bumpTex.xyz, 
		ratio).xy;
	

	//this may work, try out with different textureoperators..
	//vec4 colTemp = texture2DProj(_refractSceneTexture, refracted); 
	vec4 colTemp;
	//colTemp = texture(_refractSceneTexture, refracted.xy); 
	//colTemp = texture2DProj(_refractSceneTexture, refracted); 
	colTemp = texture(_refractSceneTexture, screenUV) * 0.78;
	//colTemp = colTemp + vec4(0.1, 0.1, 0.1, 0.1);

	colTemp = mix(colTemp, vec4(0.1, 0.1, 0.1, 0.1), 0.1);

	color = colTemp;
	//color = vec4(1.,1.,1.,1.);
	//color = bumpTex;
}
